import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol-authentication';

import { _MODULE_CONFIG } from './config/token';

import { AuthenticationProtocolService } from './services/authentication-protocol.service';

const SERVICES = [AuthenticationProtocolService];

@NgModule({})
export class AuthenticationProtocolRootModule {}

@NgModule({})
export class AuthenticationProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<AuthenticationProtocolRootModule> {
    return {
      ngModule: AuthenticationProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
