import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol-sync';

import { _MODULE_CONFIG } from './config/token';

import { SyncProtocolService } from './services/sync-protocol.service';

const SERVICES = [SyncProtocolService];

@NgModule({})
export class SyncProtocolRootModule {}

@NgModule({})
export class SyncProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<SyncProtocolRootModule> {
    return {
      ngModule: SyncProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
