import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol';

import { _MODULE_CONFIG } from './config/token';

import { ProtocolService } from './services/protocol.service';

const SERVICES = [ProtocolService];

@NgModule({})
export class ProtocolRootModule {}

@NgModule({})
export class ProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<ProtocolRootModule> {
    return {
      ngModule: ProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
