import { createReducer, on } from '@ngrx/store';
import { initialState } from './state';
import { versionInfo2Success, urlInfoSuccess } from './actions';

export const reducer = createReducer(
  initialState,
  on(versionInfo2Success, (state, action) => {
    return {
      ...state,
      versionInfo2Response: {
        ...state.versionInfo2Response,
        ...action.res
      }
    };
  }),
  on(urlInfoSuccess, (state, action) => {
    return {
      ...state,
      urlInfoResponse: {
        ...state.urlInfoResponse,
        ...action.res
      }
    };
  })
);
